local datafile = require "datafile"
local etlua = require "etlua"
local pp = require "pl.pretty"

local term = require "lsup.term"
local graph = require "lsup.graph"

local pkar = require "pocket_archive"


local M = {}

M.generate_idx = function()
    local obj_idx = {}
    local index_ts = graph.list(pkar.store)
    for gr_uri in pairs(index_ts) do
        local obj = {}
        gr = graph.get(gr_uri, pkar.store)
        for trp in gr:lookup(gr_uri, term.new_iriref("dc:title")) do
            if trp.o then obj.title = trp.o end
        end
        if obj.title then obj_idx[gr_uri.data] = obj end
    end

    local fh = datafile.open("templates/index.html")
    local idx_tpl, err = etlua.compile(fh:read("a"))
    if not idx then error(err) end
    pp.dump(obj_idx)
    print(idx_tpl({obj_idx = obj_idx, term = term}))
end


return M
